"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const md5_1 = __importDefault(require("md5"));
const persistors_1 = __importDefault(require("../persistors"));
const cache = (config) => {
    const persistor = persistors_1.default.create(config);
    const getKey = (url) => (0, md5_1.default)(url);
    const cache = {
        has: async (url) => {
            return persistor.has(getKey(url));
        },
        get: async (url) => persistor.read(getKey(url)),
        set: async (url, result) => {
            return persistor.save(getKey(url), result.data);
        },
    };
    return cache;
};
exports.default = cache;
