"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const cohercer_1 = __importDefault(require("../utils/cohercer"));
const blur = ({ value }) => {
    const v = (0, cohercer_1.default)(value, 'Blur must be a value between 0.3 and 1000.', 'blur.html')
        .toFloat()
        .min(0.3)
        .max(1000)
        .value();
    return [
        {
            name: 'blur',
            op: async ({ image: sharp }) => sharp.blur(v),
            params: [v],
        },
    ];
};
exports.default = blur;
