"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const cohercer_1 = __importDefault(require("../utils/cohercer"));
const flip = ({ value }) => {
    const operation = value !== 'true'
        ? (0, cohercer_1.default)(value, 'Flip accepts "x" or "y" as values.', 'flip.html')
            .toString()
            .enum(['x', 'y'])
            .value()
            .toLowerCase()
        : 'x';
    const method = !operation || operation === 'x' ? 'flop' : 'flip';
    return [
        {
            name: 'flip',
            op: async ({ image }) => image[method](),
            params: [operation],
        },
    ];
};
exports.default = flip;
