"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const cohercer_1 = __importDefault(require("../utils/cohercer"));
const misc_1 = require("../utils/misc");
const progressive = ({ value }) => {
    const progressive = (0, cohercer_1.default)(value, 'Progressive value is not valid.', 'progressive.html')
        .toBool()
        .value();
    return [
        {
            name: 'progressive',
            op: async ({ image, otherOps }) => {
                const format = await (0, misc_1.getOutputType)(image, otherOps);
                switch (format) {
                    case 'jpeg':
                    case 'jpg':
                        return image.jpeg({ progressive });
                    case 'png':
                        return image.png({ progressive });
                    default:
                        return image;
                }
            },
            params: [progressive],
        },
    ];
};
exports.default = progressive;
