import { Sharp } from 'sharp';
import { Normalizer, Operation } from '..';
import { Color } from '../../utils/colors';
import { GRAVITY } from '../../utils/gravity';
import { RawOperation } from '../../utils/operationParser';
export type ResizeModeOperator = (opt: {
    image: Sharp;
    otherOps: Operation[];
}) => (opt: {
    width: number | null;
    height: number | null;
    iar?: boolean;
    gravity?: GRAVITY;
    background?: Color;
}) => Promise<Sharp>;
export interface ResizeRawOp extends RawOperation {
    s: string;
    m?: string;
    iar?: string;
    g?: string;
    b?: string;
}
/**
 *
 * @param {String} value Value in the format
 */
declare const resize: Normalizer<ResizeRawOp>;
export default resize;
