"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const cohercer_1 = __importDefault(require("../utils/cohercer"));
const colors_1 = require("../utils/colors");
const rotate = ({ v, b }) => {
    let angle;
    if (v !== 'auto') {
        angle = (0, cohercer_1.default)(v, 'Angle must be a number', 'rotate.html')
            .toInt()
            .value();
    }
    else {
        angle = undefined;
    }
    const options = {};
    if (b) {
        options.background = (0, colors_1.getColorFromParameter)(b);
    }
    return [
        {
            name: 'rotate',
            op: async ({ image }) => image.rotate(angle, options),
            params: [angle, options],
        },
    ];
};
exports.default = rotate;
