/// <reference types="node" />
import { AugmentedRequestHandler, ServerRequest } from 'microrouter';
import { Logger } from 'pino';
import type { Config } from '../config/default';
export declare const PLUGIN_IGNORE_RESULT: unique symbol;
export interface Plugin {
    urlTransform?: (url: string, req: ServerRequest) => Promise<string>;
    inputImageLoader?: (imageUrl: string) => Promise<Buffer | typeof PLUGIN_IGNORE_RESULT | null>;
    getMiddlewares?: () => Array<(next: AugmentedRequestHandler) => AugmentedRequestHandler>;
}
export type PluginConstructor = (opt: {
    config: Config;
    PLUGIN_IGNORE_RESULT: typeof PLUGIN_IGNORE_RESULT;
}) => Plugin;
export type PluginManager = Required<Plugin>;
declare const pluginLoader: (config: Config, logger?: Logger) => PluginManager;
export default pluginLoader;
