"use strict";
/* eslint-env jest */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initialise = void 0;
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const configuring_1 = require("configuring");
const got_1 = __importDefault(require("got"));
const node_fetch_1 = __importDefault(require("node-fetch"));
const default_1 = __importDefault(require("../../config/default"));
const test_1 = __importDefault(require("../../config/test"));
const fs = fs_1.default.promises;
const cache = new Map();
node_fetch_1.default.mockImplementation(async (url) => {
    const knownLocation = 'https://caravaggio.ramielcreations.com/docs/assets/example';
    if (url.indexOf(knownLocation) === 0) {
        const relativePath = url.slice(knownLocation.length);
        let data;
        if (cache.has(relativePath)) {
            data = cache.get(relativePath);
        }
        else {
            data = await fs.readFile(path_1.default.join(__dirname, '..', 'fixtures', 'test-images', relativePath));
            cache.set(relativePath, data);
        }
        return { buffer: async () => data };
    }
    const response = await (0, got_1.default)(url, {});
    return { buffer: () => response.body };
});
const initialise = () => {
    const configManager = (0, configuring_1.createConfigManager)({
        configurations: {
            default: default_1.default,
            test: test_1.default,
        },
    });
    return configManager;
};
exports.initialise = initialise;
