import { ServerRequest, ServerResponse } from 'microrouter';
import { Config } from '../config/default';
import { CacheArtifact, CacheArtifactType } from '../persistors';
import { PipelineResult } from '../pipeline';
interface SendArtifact extends Omit<CacheArtifact, 'type'>, PipelineResult {
    type?: CacheArtifactType;
}
export type CacheControlStrategy = 'public' | 'private' | 'skip';
declare const senderCreator: (config: Config) => {
    sendImage: (resource: SendArtifact, req: ServerRequest, res: ServerResponse, cacheStrategy?: CacheControlStrategy) => Promise<void>;
};
export default senderCreator;
